#
#  1024 bytes Scan Line Width Mode has been heavily optimized.
#
#int bpp8_bitblt_1024(int x,int y,int w,int h,char *bmp)
#{
#  int n;
#  int addr = y * 1024 + x;
#  unsigned char * gp = vga_getgraphmem();
#  unsigned char * p  = gp;
#  unsigned char * s  = bmp;
#  int page = addr >>16;
#  int dx = 1024 - w;
#  
#  vga_setpage(page);
#  addr &= 0xffff;
#  p   += addr;
#  
#  for (n=0;n<h;n++) {
#    if (addr>0xffff) {
#      page++;
#      vga_setpage(page);
#      addr &= 0xffff;
#      p = gp + addr;
#    }
#    {
#      register int i;
#      for (i=0;i<w;i++,p++,s++) *p = *s;
#      p += dx;
#    }
#    addr += 1024;
#  }
#  
#  return 1;
#}
#
#  checked - but even slower, ???
#

	.file	"bpp8_bitblt_1024.c"
	.version	"01.01"
gcc2_compiled.:
.text
	.align 4
.globl bpp8_bitblt_1024
	.type	 bpp8_bitblt_1024,@function
bpp8_bitblt_1024:
	pushl %ebp
	movl %esp,%ebp
	subl $28,%esp
	pushl %esi
	pushl %ebx

# p = gp = vga_getgraphmem();
	call vga_getgraphmem
	movl %eax,-12(%ebp)
	movl %eax,-16(%ebp)

# s = bmp
	movl 24(%ebp),%eax
	movl %eax,-20(%ebp)

# dx = 1024 - w
	movl $1024,%eax
	subl 16(%ebp),%eax
	movl %eax,-28(%ebp)

# addr = y * 1024 + x
	movl 12(%ebp),%eax
	sall $10,%eax
	movl 8(%ebp),%esi
	addl %esi,%eax
	movl %eax,-8(%ebp)

# page = addr >> 16;
	sarl $16,%eax
	movl %eax,-24(%ebp)

# vga_setpage(page);
	pushl %eax
	call vga_setpage
	addl $4,%esp

# x = w/4, y = w%4
	movl 16(%ebp),%eax
	sarl $2,%eax
	movl %eax,8(%ebp)
	movl 16(%ebp),%eax
	andl $3,%eax
	movl %eax,12(%ebp)

# ecx = h, edi = addr, eax = s, edx = p
# addr &= 0xffff, p += addr

	movl 20(%ebp),%ecx   
	movl -8(%ebp),%edi
	andl $65535,%edi
	movl -16(%ebp),%edx
	addl %edi,%edx
	movl -20(%ebp),%eax
.L2:
# if (addr>0xffff) {
	cmpl $65535,%edi
	jle .L6
# vga_setpage(++page);
	movl %edi,-8(%ebp)
	movl %ecx,-4(%ebp)
	movl %eax,-20(%ebp)
	incl -24(%ebp)
	movl -24(%ebp),%eax
	pushl %eax
	call vga_setpage
	addl $4,%esp
	movl -20(%ebp),%eax
	movl -8(%ebp),%edi
	movl -4(%ebp),%ecx
# addr &= 0xffff; p = gp + addr
	andl $65535,%edi
	movl -12(%ebp),%edx
	addl %edi,%edx
# }
.L6:
# eax = s, edx = p, ecx = w
	movl	%ecx,%esi
	movl	8(%ebp),%ecx

	cmpl	$0,%ecx
	jz	.L8
.L7:
	movl	(%eax),%ebx
	movl	%ebx,(%edx)
	addl	$4,%eax
	addl	$4,%edx
	loop	.L7
.L8:
	mov	12(%ebp),%ecx
	cmpl	$0,%ecx
	jz	.L10
.L9:
	movb	(%eax),%bl
	movb	%bl,(%edx)
	incl	%eax
	incl	%edx
	loop	.L9
.L10:
	movl	%esi,%ecx

# p+=1024, s = eax(s+=w), addr += 1024
	addl	-28(%ebp),%edx  # p += dx
	addl	$1024,%edi      # addr+=1024
	loop	.L2  

	movl $1,%eax
	leal -36(%ebp),%esp
	popl %ebx
	popl %esi
	leave
	ret
.Lfe1:
	.size	 bpp8_bitblt_1024,.Lfe1-bpp8_bitblt_1024
	.ident	"GCC: (GNU) 2.7.2.3"
